=== debian/changelog ===
fdmdv2 (0.96.6.1592-1) unstable; urgency=low

  * New upstream 0.96.6 tagged release r1592

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 08 May 2014 19:32:42 -0400

fdmdv2 (0.96.5.1353-1) experimental; urgency=low

  * Upstream subversion r1353
  * build-depend upon libwxgtk3.0-dev (Closes: #735959)
    remove wxwidgets tarball from source (Closes: #735942, #736002)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 19 Jan 2014 15:25:41 -0500

fdmdv2 (0.96.5.1328-1) experimental; urgency=low

  * New upstream subversion r1328 (AKA 0.96.5 Beta)
  * Update wxWidgets 2.9.5 version
  * cleanup source - see debian/rules get-orig-source, (Closes: #706184)
  * HID-PTT patch included

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 30 Aug 2013 23:16:27 -0400

fdmdv2 (0.96.1-1) experimental; urgency=low

  * FreeDV.org Dayton 2013 packages
  * New upstream subversion r1247

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 11 May 2013 10:43:03 -0400

fdmdv2 (0.0.1235-1) experimental; urgency=low

  * New upstream svn r1235 (Closes: #706184)
  * Fancy source package for single binary freedv package for Wheezy
  * HID-PTT patch included

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 26 Apr 2013 20:44:30 -0400
